function [NcutDiscrete,NcutEigenvectors,NcutEigenvalues,T] = ...
    clusterNcut(W,vcdf,ds,xvec,yvec,kstart,kend,Wparams,D50color,cmap,edgecol)
%
% uses Shi code to compute clusters with Ncut
% needs a similarity matrix W just like von luxborg method
%
% kstart: min number of clusters to examine (>=2)
% kend: max number of clusters to examine >= kstart
%
% Wparams = parameters that went into creating W
%   [numCells sig1 sig2 metric]

if kend < kstart
    error('kend < kstart!\n')
end

a = pwd;

ny = length(yvec);
nx = length(xvec);
numNodes = ny*nx;

cd('/Users/peternelson/Documents/Research/objective patch def/development2/NcutClustering_7')
main
cd common_files

if D50color~=1
    figure,
    jj=1;
    for k = kstart:kend; %number of clusters
        [NcutDiscrete,NcutEigenvectors,NcutEigenvalues] = ncutW(W,k);

        NcutIDX = zeros(numNodes,1);
        for i=1:k
            inds = find(NcutDiscrete(:,i) == 1);
            NcutIDX(inds) = i;
        end

    %     figure,
        subplot(ceil((kend-kstart)/2)+1,2,jj)
        imagesc(xvec,yvec,reshape(NcutIDX,ny,nx))
        shading flat
        axis equal
        title(['NCut, k = ' num2str(i)]);
        set(gca,'YDir','reverse')
        ylim([min(yvec) max(yvec)])
        xlim([min(xvec) max(xvec)])

        set(gca,'TickDir','out')

        jj=jj+1;
    end
    L1 = ['Shi Ncut method'];
    L2 = ['nCells: ' num2str(Wparams(1)) ', sig1: ' num2str(Wparams(2)) ...
        ', sig2: ' num2str(Wparams(3)) ', metric: ' num2str(Wparams(4))];

    tit{1} = L1;
    tit{2} = L2;
    supAxes = [0.075 0.075 0.85 0.85]; 

    suplabel(tit,'t',supAxes);
else
    kvec = kstart:1:kend;
    kvec = [2 7 3 8 4 9 5 10 6 11];
    T = zeros(numNodes,length(kvec));

    for i=1:length(kvec)
        k = kvec(i);
        [NcutDiscrete,NcutEigenvectors,NcutEigenvalues] = ncutW(W,k);
        for j=1:k
            inds = find(NcutDiscrete(:,j) == 1);
            T(inds,i) = j;
        end
    end
    
    L1 = ['Shi Ncut method'];
    L2 = ['nCells: ' num2str(Wparams(1)) ', sig1: ' num2str(Wparams(2)) ...
        ', sig2: ' num2str(Wparams(3)) ', metric: ' num2str(Wparams(4))];

    titstr{1} = L1;
    titstr{2} = L2;

    mapD50color(T,vcdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);
    

    
end

cd(a)

    
