function M = filterGSDs(M2,hsize,sigma)
%
% reads in M and applies a Gaussian filter to M.cdf and M.pdf

M = M2;

[ny,nx,nd] = size(M.pdf);

vec = [-hsize/2 + 0.5 :1: hsize/2 - 0.5];
[XI,YI] = meshgrid(vec,vec);

win = fspecial('gaussian',hsize,sigma);
% win = win ./ max(win(:)); %normalize between 0 and 1
figure
mesh(XI,YI,win)
tit{1} = 'Gaussian filter';
tit{2} = ['hsize = ' num2str(hsize) ', sigma = ' num2str(sigma)];
title(tit);

pdftemp = zeros(size(M.pdf));

for i=1:nd
    temp = M.pdf(:,:,i);
    pdftemp(:,:,i) = filter2(win,temp);
end

% renormalize pdfs since some won't sum to 1 anymore
pdftemp = pdftemp./repmat(sum(pdftemp,3),[1 1 nd]);

%reconstruct cdf
cdftemp = cumsum(pdftemp,3).*100;
cdftemp = cat(3,zeros(ny,nx),cdftemp);

M.pdf = pdftemp;
M.cdf = cdftemp;

clear cdftemp pdftemp

% recalculate D50, Dg, sig, D16, D84

for i=1:ny
    for j=1:nx
        cdfin = squeeze(M.cdf(i,j,:));
        Din = M.ds;
%         M.D16(i,j) = finer(cdfin,Din,16);
%         M.D50(i,j) = finer(cdfin,Din,50);
%         M.D84(i,j) = finer(cdfin,Din,84);
        M.D16(i,j) = calcDx(Din,cdfin,16);
        M.D50(i,j) = calcDx(Din,cdfin,50);
        M.D84(i,j) = calcDx(Din,cdfin,84);
        M.Dg(i,j) = calcDg(Din,cdfin);
        M.sig(i,j) = calcSig(Din,cdfin);
    end
end

        




end


% %subfunction finer
% function out = finer(cdfin,Din,val)
%     phiin = log2(Din);
%     phi_interp = interp1(cdfin,phiin,val);
%     out = 2.^phi_interp;
% end