function T = mapAgglomClusters(vcdf,ds,xvec,yvec,L,kvec,D50color,cmap,edgecol)
%kvec is a vector of k values for which we will partition the dendrogram

% T = cluster(L,'maxclust',k);

fontsize = 12;

ny = length(yvec);
nx = length(xvec);
% [ny,nx] = size(M.x);

[numNodes,nd] = size(vcdf);

if D50color ~= 1
    figure;

    jj=1;
    for i=1:length(kvec)
        k = kvec(i);
        T = cluster(L,'maxclust',k);

        subplot(ceil(length(kvec)/2),2,jj);

        imagesc(xvec,yvec,reshape(T,ny,nx))
        % pcolor(M.x,M.y,reshape(T,ny,nx))
        % shading flat
        axis equal
        title(['Agglomerative, k = ',num2str(k)]);
        set(gca,'YDir','reverse')
        colormap('lines')
        ylim([min(yvec) max(yvec)])
        xlim([min(xvec) max(xvec)])

        set(gca,'TickDir','out')

        jj=jj+1;
    end
else
    T = zeros(numNodes,length(kvec));

    for i=1:length(kvec)
        k = kvec(i);
        T(:,i) = cluster(L,'maxclust',k');
    end

    titstr = 'Agglomerative';
    mapD50color(T,vcdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);

end

