function T = plotClustered_vonlux(u_sort,vcdf,ds,xvec,yvec,kstart,kend,Wparams,D50color,cmap,edgecol)
% kstart and kend are end points for the number of clusters to map. 
%   set kstart = kend to make a single map.


ny = length(yvec);
nx = length(xvec);
numNodes = ny*nx;

if D50color~=1

    figure,
    jj=1;
    for i=kstart:kend
        U = u_sort(:,1:i);
        IDX = kmeans(U,i,'replicates',10,'EmptyAction','drop');
    %     figure,
        subplot(ceil((kend-kstart)/2)+1,2,jj);
        imagesc(xvec,yvec,reshape(IDX,ny,nx))
        shading flat
        axis equal
        title(strcat('k = ',num2str(i)));
        set(gca,'YDir','reverse')
        ylim([min(yvec) max(yvec)])

        set(gca,'TickDir','out')

        jj=jj+1;
    end

    L1 = ['Von Luxburg method'];
    L2 = ['nCells: ' num2str(Wparams(1)) ', sig1: ' num2str(Wparams(2)) ...
        ', sig2: ' num2str(Wparams(3)) ', metric: ' num2str(Wparams(4))];

    tit{1} = L1;
    tit{2} = L2;
    supAxes = [0.075 0.075 0.85 0.85]; 

    suplabel(tit,'t',supAxes);

else
    kvec = kstart:1:kend;
    T = zeros(numNodes,length(kvec));

    for i=1:length(kvec)
        k = kvec(i);
        U = u_sort(:,1:k);
        T(:,i) = kmeans(U,k,'replicates',10,'EmptyAction','drop');
    end
    
    L1 = ['Von Luxburg Ncut method'];
    L2 = ['nCells: ' num2str(Wparams(1)) ', sig1: ' num2str(Wparams(2)) ...
        ', sig2: ' num2str(Wparams(3)) ', metric: ' num2str(Wparams(4))];

    titstr{1} = L1;
    titstr{2} = L2;

    mapD50color(T,vcdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);
    
end