function [veccdf, vecpdf] = vecGSD(M)
%
% veccdf = (nx*ny) by (nd+1) matrix where rows are cdfs corresponding to
%           M.ds
% vecpdf = (nx*ny) by nd matrix where rows are cdfs corresponding to M.di
%
% the (x,y) location of each row corresponds to [M.x(:) M.y(:)]


[ny,nx,nd] = size(M.pdf);

numNodes = nx*ny;

vecpdf = zeros(numNodes,nd);
veccdf = zeros(numNodes,nd+1);

for i=1:nd+1
    cdfmat = M.cdf(:,:,i);
    veccdf(:,i) = cdfmat(:);
    if i~=nd+1
        pdfmat = M.pdf(:,:,i);
        vecpdf(:,i) = pdfmat(:);
    end
end