% cd('/Users/peternelson/Documents/Research/objective patch def/SAFL data/endaltbar')
% load results1_cartcoords.mat; grainsvar = grains1temp; clear grains1temp;
% % load results0_cartcoords.mat; grainsvar = grains0temp; clear grains0temp;
% % load hybridgrains_cartcords.mat; grainsvar = hybridgrains; clear hybridgrains;
% cd('/Users/peternelson/Documents/Research/objective patch
% def/development')

%% intialize path and clear

clear all
close all

addpath('/Users/peternelson/Documents/Research/objective patch def/development2');

cmap = 'jet';
edgecol = 'k';
D50color = 1;

%% create M

xmin = 18;
xmax = 42;
ymin = 0.190;
ymax = 2.55;
dx = 0.3;
dy = 0.3;

psis = [2:0.25:6]';
ds = 2.^psis;

lowtrunc = 4;
% exponent = 2;
exponent = 2;

toy = 0;

%ratio of window size to grid size, perhaps useful for averaging/smoothing.
%although applying a gaussian filter to the base data would probably be
%better.
wRatio = 1.5; 

% [M, xvec, yvec] = createM('hybridgrains_cartcoords.mat', xmin, xmax, ymin, ymax, dx, dy, ds,...
%     wRatio, toy, lowtrunc, exponent);

[M, xvec, yvec] = createM('results1_cartcoords.mat', xmin, xmax, ymin, ymax, dx, dy, ds,...
    wRatio, toy, lowtrunc, exponent);

% copy to M2 for possible filtering
M2 = M;

figure,
% set(gcf,'Position',[440   227   851   551])
% set(gcf,'PaperPositionMode','auto')
plotD50Dgsig(M2,xvec,yvec);

%% apply gaussian filter to GSDs

hsize = 11;
sigma = 0.6;
M = filterGSDs(M2,hsize,sigma);
figure,
plotD50Dgsig(M,xvec,yvec);



%% transform gsd data into a list
% make veccdf and vecpdf, where each row will be a cdf or a pdf
% corresponding to the M.ds or M.di vector. Each row index will correspond
% to the vectorized (x,y) coordinates.

[veccdf, vecpdf] = vecGSD(M);

%% plot all cdfs

figure,
plot(M.ds,veccdf,'-')
set(gca,'XScale','log')
ylabel('Percent finer')
xlabel('D (mm)')
xlim([min(M.ds) max(M.ds)])
ylim([0 100])
title('All CDFs')

%% plot all pdfs

figure,
plot(M.di,vecpdf,'-')
set(gca,'XScale','log')
ylabel('Percent')
xlabel('D (mm)')
xlim([min(M.ds) max(M.ds)]) %keep ds for consistency with cdf plot
title('All PDFs')



%% kmeans on cdfs
% k = 4;
kvec = 2:40;
T = kmeansgsd2(M,xvec,yvec,veccdf,kvec,0,0,D50color,cmap,edgecol);

%%
exponent = 2;
    alpha = 0.01;
    [pcellKS,hcellKS,Tnew]=KSTestnew(T,M,alpha,xvec,yvec,exponent);
    
%%    
    titstr = 'Kmeans Tnew';
    mapD50color(Tnew,veccdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);


%%
%%%%%%%%%%%%%%%%%%% spectral clustering stuff: %%%%%%%%%%%%%%%%%%%%%%

%% compute similarity matrix

numCells = 10; %radius over which we will allow nodes to be connected.
r = (numCells+ 0.01)*sqrt(dx^2 + dy^2);
sig1 = 0.008;
sig2 = 10;
metric = 1;
W = createSimilarity(veccdf,M,numCells,sig1,sig2,metric,dx,dy);
Wparams = [numCells sig1 sig2 metric];

%% plot similarity matrix
figure,
plotW(W);

%%

%%%%%%%%%%%%%%%%%% start of Shi code for Ncut %%%%%%%%%%%%%%%%

kstart = 2;
kend = 11;
[NcutDiscrete,NcutEigenvectors,NcutEigenvalues,T] = ...
    clusterNcut(W,veccdf,M.ds,xvec,yvec,kstart,kend,Wparams,D50color,cmap,edgecol);

%%
%     alpha = 0.05;
%     figureon = 1;
%     [KScell,pvalcell,Hcell,T50cell]=kolmogorovTest(T,M,vcdf,ds,alpha,figureon);
%     [pcellranksum,hcellranksum] = ranksumTest(T,M,alpha,xvec,yvec);
    exponent = 2;
    alpha = 0.01;
    [pcellKS,hcellKS,Tnew]=KSTestnew(T,M,alpha,xvec,yvec,exponent);
  
    %% plot clusters based on Tnew

%     kvec = kstart:kend;
kvec = 30:40;
titstr = 'Shi Ncut Tnew';
    mapD50color(Tnew,veccdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);


%%
%%%%%%%%%%%%%% start of von Luxburg spectral clustering %%%%%%%%%%

k = 50; %number of eigenvectors to compute
[u_sort,evals_sort] = spectral_vonlux(W,k);

%% plot eigenvalues
figure,
plot(evals_sort,'.k')
xlabel('Eigenvalue','FontSize',16)
ylabel('Value','FontSize',16)
set(gca,'FontSize',16)

%% plot eigenvectors

kstart = 2;
kend = 5;
plot_evecs(u_sort,M,kstart,kend);

%% plot map of clustered data

kstart = 2;
kend = 11;
T = plotClustered_vonlux(u_sort,veccdf,M.ds,xvec,yvec,kstart,kend,Wparams,D50color,cmap,edgecol);

%%

exponent = 2;
    alpha = 0.01;
    [pcellKS,hcellKS,Tnew]=KSTestnew(T,M,alpha,xvec,yvec,exponent);
    
        %% plot clusters based on Tnew

    kvec = kstart:kend;
titstr = 'von Luxburg Ncut Tnew';
    mapD50color(Tnew,veccdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);
%%%%%%%%%% end of von luxburg %%%%%%%%%%%%%


%%

%%%%%%%%%%%%%%%%%% agglomerative clustering %%%%%%%%%%%%%%%%%%%%

%% compute adjacency matrix
% adjacency matrix for the points in M (numNodes by numNodes)
[ny,nx,nd] = size(M.pdf);
A = createAdjacency(nx,ny,8);
%figure,spy(A)

%%

metric = 1; %1:cityblock, 2:euclidean

[L,veccdf2,rank] = createLinkage2(veccdf,A,metric);
% [L,veccdf2,rank] = createLinkage2(M.D50(:),A,metric);

L2 = L;
% L2(:,3) = rank(nx*ny+1:length(rank));
L2(:,3) = 1:length(L);

%dendrogram
figure,
set(0,'RecursionLimit',1000);
H = dendrogram(L2,0);

%% clustering

% for k=250:-10:10
% k=100;

% kvec = 2:2:20;
kvec=2:40;
% kvec=20:20:240;
kvec = [2 12 4 14 6 16 8 18 10 20];
kvec = [22 32 24 34 26 36 28 38 30 40];

% figure,
T = mapAgglomClusters(veccdf,M.ds,xvec,yvec,L2,kvec,D50color,cmap,edgecol);
% pause(0.25)
% end

%%

exponent = 2;
    alpha = 0.01;
    [pcellKS,hcellKS,Tnew]=KSTestnew(T,M,alpha,xvec,yvec,exponent);


%% plot clusters based on Tnew

titstr = 'Agglomerative Tnew';
    mapD50color(Tnew,veccdf,ds,xvec,yvec,kvec,titstr,cmap,edgecol);




